package cn.cecep.talroad.controller;

import cn.cecep.talroad.common.core.exception.CommonException;
import cn.cecep.talroad.common.core.utils.poi.ExcelUtil;
import cn.cecep.talroad.common.core.web.controller.BasesController;
import cn.cecep.talroad.common.core.web.domain.AjaxResults;
import cn.cecep.talroad.common.log.annotation.Log;
import cn.cecep.talroad.common.log.enums.BusinessType;
import cn.cecep.talroad.common.security.annotation.RequiresPermissions;
import cn.cecep.talroad.domain.PcIndustry;
import cn.cecep.talroad.service.IPcIndustryService;
import cn.cecep.talroad.vo.PcIndustryVo;
import cn.cecep.talroad.vo.query.PcIndustryQuery;
import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.security.InvalidParameterException;
import java.util.Arrays;
import java.util.List;


/**
 * * 开发公司：中节能天融科技有限公司
 * 行业Controller 控制层
 *
 * @author szhpt
 * @date 2023-01-10*/
@Api(tags = "基础信息--行业")
@RestController
@RequestMapping("/pcIndustry")
public class PcIndustryController extends BasesController
{
    @Autowired
    private IPcIndustryService pcIndustryService;

    /**
     * 查询行业列表
     */
    @ApiOperation(value = "查询行业")
    @GetMapping("/list")
    public AjaxResults<IPage<PcIndustry>> list(PcIndustryQuery pcIndustry)
    {
        Page<PcIndustry> page = new Page<>(pcIndustry.getPageNum(), pcIndustry.getPageSize());
        IPage<PcIndustry> list = pcIndustryService.page(page, PcIndustryQuery.createLambdaQueryWrapper(pcIndustry));
        return AjaxResults.success(list);
    }

    /**
     * 查询行业列表
     */
    @ApiOperation(value = "行业下拉框列表")
    @GetMapping("/selectList")
    public AjaxResults<List<PcIndustry>> selectList(PcIndustry pcIndustry)
    {
        return AjaxResults.success(pcIndustryService.selectPcIndustryList(pcIndustry));
    }
    /**
     * 查询行业列表
     */
    @ApiOperation(value = "排污许可行业下拉框列表")
    @GetMapping("/industryPermissionList")
    public AjaxResults<List<PcIndustry>> industryPermissionList(PcIndustry pcIndustry)
    {
        return AjaxResults.success(pcIndustryService.industryPermissionList(pcIndustry));
    }


    /**
     * 导出行业列表
     */
    @ApiOperation(value = "导出行业")
    @Log(title = "行业", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, PcIndustry pcIndustry)
    {
        List<PcIndustry> list = pcIndustryService.selectPcIndustryList(pcIndustry);
        ExcelUtil<PcIndustry> util = new ExcelUtil<PcIndustry>(PcIndustry.class);
        util.exportExcel(response, list, "行业数据");
    }

    /**
     * 获取行业详细信息
     */
    @ApiOperation(value = "获取行业详细信息")
    @PostMapping(value = "/{id}")
    public AjaxResults<PcIndustry> getInfo(@PathVariable("id") Integer id) {
        return AjaxResults.success(pcIndustryService.getById(id));
    }
    /**
     * 新增行业
     */
    @ApiOperation(value = "新增行业")
    @Log(title = "行业", businessType = BusinessType.INSERT)
    @PostMapping(value = "/add")
    public AjaxResults<Boolean> add(@RequestBody PcIndustry pcIndustry) {
        return toAjax(pcIndustryService.save(pcIndustry));
    }
    /**
     * 修改行业
     */
    @ApiOperation(value = "修改行业")
    @Log(title = "行业", businessType = BusinessType.UPDATE)
    @PostMapping(value = "/edit")
    public AjaxResults<Boolean> edit(@RequestBody PcIndustryVo pcIndustryVo) {
        if(ObjectUtil.isEmpty(pcIndustryVo)){
            throw new InvalidParameterException("参数为空");
        }
        if(ObjectUtil.isEmpty(pcIndustryVo.getId())){
            throw new InvalidParameterException("参数id为空");
        }
        PcIndustry pcIndustry = pcIndustryService.getById(pcIndustryVo.getId());
        if(ObjectUtil.isEmpty(pcIndustry)){
            throw new CommonException(StrUtil.format("根据id{}查询不到数据", pcIndustryVo.getId()));
        }
        //赋值
        BeanUtil.copyProperties(pcIndustryVo,pcIndustry);
        return toAjax(pcIndustryService.saveOrUpdate(pcIndustry));
    }

    /**
     * 删除行业
     */
    @ApiOperation(value = "删除行业")
    @RequiresPermissions("talroad:industry:remove")
    @Log(title = "行业", businessType = BusinessType.DELETE)
    @PostMapping("/{ids}")
    public AjaxResults<Boolean> remove(@PathVariable String[] ids) {
        return toAjax(pcIndustryService.removeByIds(Arrays.asList(ids)));
    }
}
